#include "testApp.h"





//--------------------------------------------------------------
void testApp::setup(){	 
	
	//ofSetFrameRate(30);
	//vidGrabber.setVerbose(true);
	
	vidGrabber.initGrabber();
	
	camWidth 		= vidGrabber.width;	// try to grab at this size. 
	camHeight 		= vidGrabber.height;
	
	
	cout<<"cam w/h"<<camWidth<<camHeight<<endl;
	//vidGrabber.listDevices();
	
	videoInverted 	= new unsigned char[camWidth*camHeight];
	videoTexture.allocate(camWidth/3,camHeight/3, GL_RGB);
	
	d=true;
	f=false;
	
}


//--------------------------------------------------------------
void testApp::update(){
	
	ofBackground(100,100,100);

	unsigned char * temp;
	temp = NULL;
	if(!f)
	{
		temp = vidGrabber.getPixels();
	}
	f=!f;
	if(temp!=NULL)
	{
		vidGrabber.unlock();
		pixels = temp;
		
		videoTexture.loadData(pixels, camWidth/3, camHeight/3, GL_RGB);
	}
	
	
}

//--------------------------------------------------------------
void testApp::draw(){
	ofSetColor(0xffffff);
	videoTexture.draw(20,20);
	
	vidGrabber.draw(300,20);
	
	ofSetColor(0,0,0);
	ofDrawBitmapString(ofToString(ofGetFrameRate()),10,600);
}


//--------------------------------------------------------------
void testApp::keyPressed  (int key){ 
	
	// in fullscreen mode, on a pc at least, the 
	// first time video settings the come up
	// they come up *under* the fullscreen window
	// use alt-tab to navigate to the settings
	// window. we are working on a fix for this...
	
	if (key == 's' || key == 'S'){
		//vidGrabber.videoSettings();
		
		d=!d;
	}
	
	
}


//--------------------------------------------------------------
void testApp::keyReleased(int key){ 
	
}

//--------------------------------------------------------------
void testApp::mouseMoved(int x, int y ){
	
}

//--------------------------------------------------------------
void testApp::mouseDragged(int x, int y, int button){
	
}

//--------------------------------------------------------------
void testApp::mousePressed(int x, int y, int button){
	
}

//--------------------------------------------------------------
void testApp::mouseReleased(){

}
